unit Fregan;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, ToolWin, ExtCtrls, TeeProcs, TeEngine, Chart, Math,
  Series;

type
  Trgn = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    KeyboardInput1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Predict1: TMenuItem;
    PredictX1: TMenuItem;
    PredictY1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    procedure ToolButton1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure PredictX1Click(Sender: TObject);
    procedure PredictY1Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  rgn: Trgn;

implementation

uses fabout;

{$R *.DFM}
Var
  x : Array[1..4] of Single;
  y : Array[1..4] of Single;
  Exy : Array[1..4] of Single;
  Ex : Array[1..4] of Single;
  Ey : Array[1..4] of Single;
  Ex2 : Array[1..4] of Single;
  Ey2 : Array[1..4] of Single;
  a : Array[1..4] of Single;
  b : Array[1..4] of Single;
  r : Array[1..4] of Single;
  chtX: Array[1..4] of Single;
  chtY: Array[1..4] of Single;
  no, n : Integer;
  m : Single;
  Ymin, Ymax : Single;


Procedure GetCommaDat(commaline:String; Var x,y : Single);
// Expects values as X , Y. i.e.: 123.44, 443.2 - one set of vals per line
Var
  p : integer;
Begin
  While Pos(',',commaline)>0 Do Begin
    p:=Pos(',',commaline);
    x:=StrToFloat( Copy(commaline, 1, p-1) );
    commaline:=Copy(commaline, p+1, Length(commaline)-p);
  End;
  y:=StrToFloat(commaline);
End; // GetCommaDat


Procedure calcit;
Var
  q : Integer;
Begin
For q := 1 To 4 Do Begin
  b[q] := (no * Exy[q] - Ex[q] * Ey[q]) / (no * Ex2[q] - (Ex[q]*Ex[q]) );
  a[q] := (Ey[q] - b[q] * Ex[q]) / no;
  r[q] := (no * Exy[q] - Ex[q] * Ey[q]) / (Sqrt((no * Ex2[q] - (Ex[q]*Ex[q]) ) * (no * Ey2[q] - (Ey[q]*Ey[q]) ) ));
End; // for
// lin,exp,log,power;
a[2] := Exp(a[2]);
a[4] := Exp(a[4]);

rgn.label1.Caption :='Linear  Y=' + FloatToStr(a[1]) + ' +' + FloatToStr(b[1]) + ' * X';
rgn.label2.Caption :='Exp  Y=' + FloatToStr(a[2]) + ' * e ^' + FloatToStr(b[2]) + ' * X';
rgn.label3.Caption :='Log  Y=' + FloatToStr(a[3]) + ' +' + FloatToStr(b[3]) + ' * LOG(X)';
rgn.label4.Caption :='Power  Y=' + FloatToStr(a[4]) + ' * X ^' + FloatToStr(b[4]);
rgn.label5.Caption :='R=' + Format('%4.5f', [r[1]]);
rgn.label6.Caption :='R=' + Format('%4.5f', [r[2]]);
rgn.label7.Caption :='R=' + Format('%4.5f', [r[3]]);
rgn.label8.Caption :='R=' + Format('%4.5f', [r[4]]);
End; // calcit()


Procedure inpcalc;
Var
  q : Integer;
Begin
x[2] := x[1];
 y[2] := Ln(y[1]);  //  exp
x[3] := Ln(x[1]);
 y[3] := y[1];  //  log
x[4] := Ln(x[1]);
 y[4] := Ln(y[1]);  // power

For q := 1 To 4 Do Begin
  Exy[q] := Exy[q] + x[q] * y[q];
  Ex[q] := Ex[q] + x[q];
  Ey[q] := Ey[q] + y[q];
  Ex2[q] := Ex2[q] + (x[q]*x[q]);
  Ey2[q] := Ey2[q] + (y[q]*y[q]);
 End; // For
End; // inpcalc


Procedure inpdet;
Var
  q : Integer;
Begin
no := StrToINT(InputBox('No Points','Number of X and Y Data points',''));
n:=1;
If no <= 1 Then Application.Terminate;

  While n <= no Do Begin
    x[1] := StrToFloat(InputBox('X Data','Data for X info: '+IntToStr(n),''));
    y[1] := StrToFloat(InputBox('Y Data','Data for Y info: '+IntToStr(n),''));
    n := n + 1;
    inpcalc;
  End; // While
End;


procedure Trgn.ToolButton1Click(Sender: TObject);
Var
  q : Integer;
  myfile: textfile;
  FileName, temp : String;
Begin
  OpenDialog1.Filter := 'Text files (*.txt)|*.TXT|Comma Seperated Values (*.csv)|*.CSV|All Files (*.*)|*.*';
  OpenDialog1.Execute;
    FileName:=OpenDialog1.FileName;
  If FileName='' Then
    Exit;
  assignFile(myfile,FileName);
  Reset(myfile);

  While Not EOF(myfile) Do Begin
    no := no + 1;
    ReadLn(myfile,temp);
    GetCommaDat(temp, x[1], y[1]);

    inpcalc
  End; // while
  CloseFile(myfile);

  calcit;
end; //ToolButton1Click

procedure Trgn.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure Trgn.Open1Click(Sender: TObject);
begin
  ToolButton1.Click;
end;

procedure Trgn.About1Click(Sender: TObject);
begin
  AboutBox.show;
end;

procedure Trgn.ToolButton5Click(Sender: TObject);
Var
  mm : String;
begin
  y[1] := StrToFloat(InputBox('When the Y data is equal to...', 'Predict X, when Y =',''));
  x[1] := (y[1] - a[1]) / b[1];
  x[2] := (Ln(y[1] / a[2])) / b[2];
  x[3] := (y[1] - a[3]) / b[3];
  x[3] := Power(Exp(1) , (x[3]) );
  x[4] := Power( (y[1] / a[4]) , (1 / b[4]) );

  mm := 'When Y='+ FloatToStr(y[1]) + #10#13 + #10#13;
  mm := mm +'Linear  X=' + FloatToStr(x[1]) + #10#13;
  mm := mm + 'Exp   X=' + FloatToStr(x[2]) + #10#13;
  mm := mm + 'Log   X=' + FloatToStr(x[3]) + #10#13;
  mm := mm + 'Power X=' + FloatToStr(x[4]);
  MessageDlg(mm, mtInformation, [mbOK], 0);
end; // Trgn.ToolButton5Click


procedure Trgn.ToolButton7Click(Sender: TObject);
Var
  mm : String;
begin
  x[1] := StrToFloat(InputBox('When the X data is equal to...', 'Predict Y, when X =',''));
  y[1] := a[1] + b[1] * x[1];
  y[2] := a[2] * Power( 2.718281828 , (b[2] * x[1]) );
  y[3] := a[3] + b[3] * Ln(x[1]);
  y[4] := a[4] * Power(x[1] , b[4]);

  mm := 'When X='+ FloatToStr(x[1]) + #10#13 + #10#13;
  mm := mm +'Linear  Y=' + FloatToStr(y[1]) + #10#13;
  mm := mm + 'Exp   Y=' + FloatToStr(y[2]) + #10#13;
  mm := mm + 'Log   Y=' + FloatToStr(y[3]) + #10#13;
  mm := mm + 'Power Y=' + FloatToStr(y[4]);
  MessageDlg(mm, mtInformation, [mbOK], 0);
end; // Trgn.ToolButton7Click

procedure Trgn.PredictX1Click(Sender: TObject);
begin
  ToolButton5.Click;
end;

procedure Trgn.PredictY1Click(Sender: TObject);
begin
  ToolButton7.Click;
end;

procedure Trgn.ToolButton3Click(Sender: TObject);
begin
  inpdet;
  calcit;
end;

end. // Program


